// Copyright 2024 Universidad Politecnica de Madrid (UPM)
// Authors: Santiago Tapia-Fernández
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

// --------------------------------------------------------------
//     ATTENTION:    DO NOT EDIT!!
// --------------------------------------------------------------
// This file has been automatically generated by Archetypes.
// Any manual changes will be overwritten the next time the file
// is regenerated.
//
// Archetype was `arty_basic_node' version 1.0.0
// Generation datetime: 2025-02-23 16:38:28.251688
// --------------------------------------------------------------


#ifndef __arty_example_sinusoid_emitter_inputs_hpp__
#define __arty_example_sinusoid_emitter_inputs_hpp__

#include <memory>
#include "rclcpp/rclcpp.hpp"

#include "std_msgs/msg/float64.hpp"

namespace arty_example_sinusoid_emitter
{

struct inputs
{
  std_msgs::msg::Float64 offset;
  double amplitude;
  double frequency;
};

class std_msgs_msg_Float64_wrapper : public std_msgs::msg::Float64
{
public:
	void init(rclcpp::Publisher<std_msgs::msg::Float64>::SharedPtr pub)
	{
		publisher = pub;
	}

	void publish() const
	{
		const std_msgs::msg::Float64 & msg = *this;
		publisher->publish(msg);
	}

	rclcpp::Publisher<std_msgs::msg::Float64>::SharedPtr publisher;
};

class outputs
{
public:
	void init(	rclcpp::Publisher<std_msgs::msg::Float64>::SharedPtr pub_sin)
	{
		sin.init(pub_sin);
	}

	std_msgs_msg_Float64_wrapper sin;
};

}  // namespace arty_example_sinusoid_emitter

#endif  // __arty_example_sinusoid_emitter_inputs_hpp__